/* 	SOM.java
	ISC234 Midterm 2011
	Name:
	Precept:
	Compile instructions:
	Descriptions:
	
*/

import java.util.Random;

public class SOM{

	private SOMNode[] map;
	private Gene[] samples;
	private int M, N;
	private Random rand;
	
	//constants that will be used by the SOM algorithm
	private double INITIAL_LEARNING_RATE;
	private double INITIAL_RADIUS;
	private int NUM_ITERATIONS;
	private double RADIUS_DECAY;
	
	public SOM(Gene[] samples, int M, int N, int NUM_ITERATIONS,
		double INITIAL_LEARNING_RATE){
	
		//initialize random generator with a fixed seed
		rand = new Random(100); //do not change this!!
		
		//allocates space for the map (note it is a 1D array of M*N nodes)
		//FILL IN
		
		
		
		
		//initializes the map so that the first M nodes in the array have 
		//coordinates (0,0), (0,1)... (0,M-1), the next M nodes are
		//(1,0), (1,1)... (1,M-1), and so forth.
		//Do not initialize the weight vectors to random values here, because
		//this is already done for you in do_cluster().
		//FILL IN
		
		
		
		
		
		
		
		//initializes the constants and sets "samples"
		//FILL IN
		
		
		
		
		
		
		
		//calculates the two hidden constants: INITIAL_RADIUS, RADIUS_DECAY
		//FILL IN
		
		
		

		
	}
	
	//already implemented
	public void do_cluster(){
		//randomly initializes the weight vector of the map nodes
		//with values from 0 to 255 (inclusive).
		for(int i=0; i<map.length; i++){
			double[] weight_vector = map[i].get_weight_vector();
			
			for(int j=0; j<weight_vector.length; j++){
				weight_vector[j] = (double) (rand.nextInt(256));
			}
			map[i].set_weight_vector(weight_vector);
		}
	
		//starts clustering
		for(int i=0; i<NUM_ITERATIONS; i++){
			do_cluster_one_iteration(i);
			
			//may be commented out if you want to turn off drawing
			draw(); 
		}
		
	}
	
	//FOR YOU TO IMPLEMENT
	public void do_cluster_one_iteration(int t){
		
		//1) clears all assignments
		//FILL IN
		
		
		
		//Any extra code
		//FILL IN
		
		
		
		//2) draws a Gene randomly, g. (uses shuffle() to randomize the 
		//order of genes, then draws gene in order in the randomized array)
		Gene[] random_order = shuffle();
		
		for(int j=0; j<random_order.length; j++){		
			Gene g = random_order[j];
			
			//3) finds best matching unit, assigns g to the node
			//4) calculates the new weight vector, by using functions in Function.java
			//FILL IN
			
			
			
			
			
		}
		
		//Any extra code
		//FILL IN
		
		
		
		
		
	}
	
	//draws the map
	public void draw(){
		StdDraw.set_defer();
		StdDraw.clear();
		new Visualizer(this);
		StdDraw.show();
	}
	
	
	//randomize the order of genes in the samples array
	public Gene[] shuffle(){
		Gene[] new_gene_order = new Gene[samples.length];
		int[] ind = new int[samples.length];
		for(int i=0; i<samples.length; i++){
			ind[i] = i;
		}
		
		for(int i=0; i<samples.length; i++){
			int r = rand.nextInt(samples.length);
			int temp = ind[i];
			ind[i] = ind[r];
			ind[r] = temp;
		}
		
		for(int i=0; i<samples.length; i++){
			new_gene_order[i] = samples[ind[i]];
		}
		
		return new_gene_order;
	}
	
	
	public SOMNode find_best_matching_unit(Gene g){
		//returns the SOM node whose weight vector is most similar to g 	
		//FILL IN
		
		
		
		
		
		
		
		return null;
	}
	
	public int get_M(){
		return this.M;
	}
	
	public int get_N(){
		return this.N;
	}
	
	//for debugging purposes
	public SOMNode[] get_map(){
		return map;	
	}
	
	
	//for debugging purposes
	public String toString(){
		String s = "";
		for(int i=0; i<map.length; i++){
			s+=map[i] + "\n";
		}
		return s;
	}
	
	//for debugging purposes - return a string representation of 
	//the constants
	public String get_constants(){
		return M + " " + N + " " + 
			INITIAL_LEARNING_RATE + " " + 
			INITIAL_RADIUS + " " + 
			NUM_ITERATIONS + " " +
			RADIUS_DECAY;
	}
	
}
