public class TestMap{

	public static void main(String[] args){
	
		Gene[] genes = TestSOM.read_dataset("color.pcl");
		int M = 3;
		int N = 2;
		int NUM_ITERATIONS = 100;
		double INITIAL_LEARNING_RATE = 0.1;
		
		SOM som = new SOM(genes, M, N, NUM_ITERATIONS, INITIAL_LEARNING_RATE);
		SOMNode[] map = som.get_map();
		
		System.out.println("Coordinates for a 3 by 2 map:");
		for(int i=0; i<map.length; i++){
			System.out.println("Node " + i + ": (" + map[i].get_x() + " " + map[i].get_y() + ")");
		}
	
	}
}